Linux mail.vriendennsm.nl 6.1.0-51-amd64 #1 SMP PREEMPT_DYNAMIC Debian 6.1.177-1 (2026-07-16) x86_64
Apache/2.4.68 (Debian)
Server IP : 217.154.75.17 & Your IP : 216.73.216.195
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
bin /
Delete
Unzip
Name
Size
Permission
Date
Action
[
66.89
KB
-rwxr-xr-x
2022-09-20 15:27
aa-enabled
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
aa-exec
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
aa-features-abi
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
ab
58.42
KB
-rwxr-xr-x
2026-06-12 05:08
addpart
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
apropos
51.29
KB
-rwxr-xr-x
2023-03-12 22:23
apt
18.31
KB
-rwxr-xr-x
2023-05-25 14:11
apt-cache
86.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-cdrom
22.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-config
26.31
KB
-rwxr-xr-x
2023-05-25 14:11
apt-extracttemplates
22.39
KB
-rwxr-xr-x
2023-05-25 14:11
apt-ftparchive
270.39
KB
-rwxr-xr-x
2023-05-25 14:11
apt-get
50.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-key
27.32
KB
-rwxr-xr-x
2023-05-25 14:11
apt-listchanges
11.96
KB
-rwxr-xr-x
2021-03-28 11:06
apt-mark
58.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-sortpkgs
38.32
KB
-rwxr-xr-x
2023-05-25 14:11
arch
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
aria_chk
5.34
MB
-rwxr-xr-x
2026-06-27 11:11
aria_dump_log
5.14
MB
-rwxr-xr-x
2026-06-27 11:11
aria_ftdump
5.15
MB
-rwxr-xr-x
2026-06-27 11:11
aria_pack
5.18
MB
-rwxr-xr-x
2026-06-27 11:11
aria_read_log
5.3
MB
-rwxr-xr-x
2026-06-27 11:11
awk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
b2sum
58.98
KB
-rwxr-xr-x
2022-09-20 15:27
base32
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
base64
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
basename
42.83
KB
-rwxr-xr-x
2022-09-20 15:27
basenc
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
bash
1.21
MB
-rwxr-xr-x
2026-05-07 20:33
bashbug
6.7
KB
-rwxr-xr-x
2026-05-07 20:33
bunzip2
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
busctl
90.5
KB
-rwxr-xr-x
2026-04-27 19:48
bzcat
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
bzcmp
2.17
KB
-rwxr-xr-x
2022-09-19 02:54
bzdiff
2.17
KB
-rwxr-xr-x
2022-09-19 02:54
bzegrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzexe
4.78
KB
-rwxr-xr-x
2021-11-27 12:25
bzfgrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzgrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzip2
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
bzip2recover
14.23
KB
-rwxr-xr-x
2022-09-19 02:54
bzless
1.27
KB
-rwxr-xr-x
2022-09-19 02:54
bzmore
1.27
KB
-rwxr-xr-x
2022-09-19 02:54
c_rehash
6.76
KB
-rwxr-xr-x
2026-06-06 19:56
captoinfo
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
cat
42.98
KB
-rwxr-xr-x
2022-09-20 15:27
catman
42.77
KB
-rwxr-xr-x
2023-03-12 22:23
certbot
14.79
MB
-rwxr-xr-x
2026-05-10 10:28
cgi-fcgi
18.08
KB
-rwxr-xr-x
2025-05-26 18:18
chage
78.49
KB
-rwxr-sr-x
2025-12-14 14:00
chardet
221
B
-rwxr-xr-x
2022-12-26 14:42
chardetect
221
B
-rwxr-xr-x
2022-12-26 14:42
chattr
14.24
KB
-rwxr-xr-x
2025-06-06 17:12
chcon
67.11
KB
-rwxr-xr-x
2022-09-20 15:27
checkgid
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
chfn
61.2
KB
-rwsr-xr-x
2025-12-14 14:00
chgrp
67.05
KB
-rwxr-xr-x
2022-09-20 15:27
chmod
62.98
KB
-rwxr-xr-x
2022-09-20 15:27
choom
54.31
KB
-rwxr-xr-x
2024-11-21 20:01
chown
71.05
KB
-rwxr-xr-x
2022-09-20 15:27
chrt
66.31
KB
-rwxr-xr-x
2024-11-21 20:01
chsh
51.64
KB
-rwsr-xr-x
2025-12-14 14:00
cksum
139.05
KB
-rwxr-xr-x
2022-09-20 15:27
clear
14.24
KB
-rwxr-xr-x
2023-05-07 14:33
clear_console
14.15
KB
-rwxr-xr-x
2026-05-07 20:33
cloud-id
972
B
-rwxr-xr-x
2026-06-01 19:13
cloud-init
976
B
-rwxr-xr-x
2026-06-01 19:13
cloud-init-per
2.06
KB
-rwxr-xr-x
2022-11-23 21:17
cloud-localds
7.21
KB
-rwxr-xr-x
2022-06-03 10:51
cmp
50.95
KB
-rwxr-xr-x
2023-02-03 19:00
col
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
colcrt
14.31
KB
-rwxr-xr-x
2024-11-21 20:01
colrm
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
column
54.31
KB
-rwxr-xr-x
2024-11-21 20:01
comm
46.92
KB
-rwxr-xr-x
2022-09-20 15:27
compose
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
corelist
15.01
KB
-rwxr-xr-x
2025-08-29 12:09
cp
147.61
KB
-rwxr-xr-x
2022-09-20 15:27
cpan
8.16
KB
-rwxr-xr-x
2025-08-29 12:09
cpan5.36-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
2025-08-29 12:09
cpio
158.56
KB
-rwxr-xr-x
2022-09-14 19:45
csplit
119.17
KB
-rwxr-xr-x
2022-09-20 15:27
ctstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
curl
274.22
KB
-rwxr-xr-x
2026-05-08 14:16
cut
46.98
KB
-rwxr-xr-x
2022-09-20 15:27
cvtsudoers
337.19
KB
-rwxr-xr-x
2026-04-11 12:01
dash
122.7
KB
-rwxr-xr-x
2023-01-05 13:20
date
119.05
KB
-rwxr-xr-x
2022-09-20 15:27
dbilogstrip
1.35
KB
-rwxr-xr-x
2026-06-09 15:14
dbiprof
6.06
KB
-rwxr-xr-x
2026-06-09 15:14
dbiproxy
5.27
KB
-rwxr-xr-x
2026-06-09 15:14
dbus-cleanup-sockets
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-daemon
238.56
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-monitor
26.23
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-run-session
14.23
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-send
30.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-update-activation-environment
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-uuidgen
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dd
87.15
KB
-rwxr-xr-x
2022-09-20 15:27
deb-systemd-helper
23.79
KB
-rwxr-xr-x
2022-07-13 19:55
deb-systemd-invoke
6.09
KB
-rwxr-xr-x
2025-08-20 18:56
debconf
2.79
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-apt-progress
11.27
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-communicate
608
B
-rwxr-xr-x
2023-01-08 21:50
debconf-copydb
1.68
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-escape
647
B
-rwxr-xr-x
2023-01-08 21:50
debconf-set-selections
2.92
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-show
1.78
KB
-rwxr-xr-x
2023-01-08 21:50
debianbts
217
B
-rwxr-xr-x
2022-12-08 11:34
decodemail
30.7
KB
-rwxr-xr-x
2023-03-03 16:00
delpart
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
devdump
180.17
KB
-rwxr-xr-x
2022-06-24 14:56
df
99.8
KB
-rwxr-xr-x
2022-09-20 15:27
dh_bash-completion
4.31
KB
-rwxr-xr-x
2021-08-28 15:26
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
2019-02-27 00:18
dh_perl_dbi
1.17
KB
-rwxr-xr-x
2026-06-09 15:14
dh_perl_openssl
1.53
KB
-rwxr-xr-x
2022-05-01 18:31
diff
151.58
KB
-rwxr-xr-x
2023-02-03 19:00
diff3
67.14
KB
-rwxr-xr-x
2023-02-03 19:00
dir
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
dircolors
50.92
KB
-rwxr-xr-x
2022-09-20 15:27
dirmngr
586.13
KB
-rwxr-xr-x
2026-01-01 14:54
dirmngr-client
106.87
KB
-rwxr-xr-x
2026-01-01 14:54
dirname
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
dirsplit
16.74
KB
-rwxr-xr-x
2006-11-25 23:13
dmesg
86.58
KB
-rwxr-xr-x
2024-11-21 20:01
dnsdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
domainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
dotlock
15.07
KB
-rwxr-sr-x
2023-03-03 16:00
dotlock.mailutils
15.07
KB
-rwxr-sr-x
2023-03-03 16:00
dpkg
310.64
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-deb
166.52
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-divert
154.55
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-query
158.58
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-realpath
4.09
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-split
126.48
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-statoverride
62.33
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-trigger
86.48
KB
-rwxr-xr-x
2026-03-07 12:15
du
171.33
KB
-rwxr-xr-x
2022-09-20 15:27
ec2metadata
8.38
KB
-rwxr-xr-x
2022-06-03 10:51
echo
42.83
KB
-rwxr-xr-x
2022-09-20 15:27
edit
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
editor
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
egrep
41
B
-rwxr-xr-x
2023-01-24 14:43
eject
82.16
KB
-rwxr-xr-x
2024-11-21 20:01
enc2xs
40.96
KB
-rwxr-xr-x
2025-08-29 12:09
encguess
3
KB
-rwxr-xr-x
2025-08-29 12:09
env
47.4
KB
-rwxr-xr-x
2022-09-20 15:27
envsubst
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
eqn
205.42
KB
-rwxr-xr-x
2023-03-07 09:38
ex
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
exonpairs
123.43
KB
-rwxr-xr-x
2020-12-22 13:24
expand
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
expiry
30.45
KB
-rwxr-sr-x
2025-12-14 14:00
expr
115.05
KB
-rwxr-xr-x
2022-09-20 15:27
factor
83.2
KB
-rwxr-xr-x
2022-09-20 15:27
faillog
22.53
KB
-rwxr-xr-x
2025-12-14 14:00
fallocate
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
false
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
fathom
151.24
KB
-rwxr-xr-x
2020-12-22 13:24
fcgistarter
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
fgrep
41
B
-rwxr-xr-x
2023-01-24 14:43
filan
96.02
KB
-rwxr-xr-x
2022-11-06 08:15
file
26.48
KB
-rwxr-xr-x
2023-01-28 18:17
fincore
34.36
KB
-rwxr-xr-x
2024-11-21 20:01
find
219.58
KB
-rwxr-xr-x
2023-01-08 18:07
findmnt
83.59
KB
-rwxr-xr-x
2024-11-21 20:01
flock
34.39
KB
-rwxr-xr-x
2024-11-21 20:01
fmt
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
fold
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
forge
135.21
KB
-rwxr-xr-x
2020-12-22 13:24
free
26.3
KB
-rwxr-xr-x
2022-12-19 06:06
frm
27.23
KB
-rwxr-xr-x
2023-03-03 16:00
frm.mailutils
27.23
KB
-rwxr-xr-x
2023-03-03 16:00
from
22.78
KB
-rwxr-xr-x
2023-03-03 16:00
from.mailutils
22.78
KB
-rwxr-xr-x
2023-03-03 16:00
funzip
22.46
KB
-rwxr-xr-x
2026-08-16 13:50
fuser
39.83
KB
-rwxr-xr-x
2022-12-13 05:27
galera_new_cluster
930
B
-rwxr-xr-x
2026-06-27 11:11
galera_recovery
3.29
KB
-rwxr-xr-x
2026-06-27 11:11
gawk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
gawkbug
6.54
KB
-rwxr-xr-x
2023-02-19 13:30
genisoimage
631.17
KB
-rwxr-xr-x
2022-06-24 14:56
geqn
205.42
KB
-rwxr-xr-x
2023-03-07 09:38
getconf
26.5
KB
-rwxr-xr-x
2026-04-27 20:14
geteltorito
6.06
KB
-rwxr-xr-x
2022-06-24 14:56
getent
35.47
KB
-rwxr-xr-x
2026-04-27 20:14
getopt
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
gettext
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
gettext.sh
5.07
KB
-rwxr-xr-x
2023-02-26 15:20
gpasswd
86.42
KB
-rwsr-xr-x
2025-12-14 14:00
gpg
1.06
MB
-rwxr-xr-x
2026-01-01 14:54
gpg-agent
425.22
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-connect-agent
154.96
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-wks-server
203
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-zip
3.43
KB
-rwxr-xr-x
2026-01-01 14:54
gpgcompose
910.27
KB
-rwxr-xr-x
2026-01-01 14:54
gpgconf
174.73
KB
-rwxr-xr-x
2026-01-01 14:54
gpgparsemail
34.3
KB
-rwxr-xr-x
2026-01-01 14:54
gpgsm
527.66
KB
-rwxr-xr-x
2026-01-01 14:54
gpgsplit
74.56
KB
-rwxr-xr-x
2026-01-01 14:54
gpgtar
147.52
KB
-rwxr-xr-x
2026-01-01 14:54
gpgv
463
KB
-rwxr-xr-x
2026-01-01 14:54
gpic
220.27
KB
-rwxr-xr-x
2023-03-07 09:38
grep
198.39
KB
-rwxr-xr-x
2023-01-24 14:43
groff
125.45
KB
-rwxr-xr-x
2023-03-07 09:38
grog
2.71
KB
-rwxr-xr-x
2023-03-07 09:38
grops
185.86
KB
-rwxr-xr-x
2023-03-07 09:38
grotty
137.48
KB
-rwxr-xr-x
2023-03-07 09:38
groups
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
growpart
29.19
KB
-rwxr-xr-x
2022-06-03 10:51
grub-editenv
374.23
KB
-rwxr-xr-x
2026-04-01 20:03
grub-file
814.7
KB
-rwxr-xr-x
2026-04-01 20:03
grub-fstest
936.38
KB
-rwxr-xr-x
2026-04-01 20:03
grub-glue-efi
245.07
KB
-rwxr-xr-x
2026-04-01 20:03
grub-kbdcomp
1.64
KB
-rwxr-xr-x
2026-04-01 20:03
grub-menulst2cfg
229.12
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkfont
273.73
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkimage
354.26
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mklayout
253.35
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mknetdir
411.02
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkpasswd-pbkdf2
257.41
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkrelpath
244.76
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkrescue
993.12
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkstandalone
487.41
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mount
759.3
KB
-rwxr-xr-x
2026-04-01 20:03
grub-render-label
827.26
KB
-rwxr-xr-x
2026-04-01 20:03
grub-script-check
272.88
KB
-rwxr-xr-x
2026-04-01 20:03
grub-syslinux2cfg
775.77
KB
-rwxr-xr-x
2026-04-01 20:03
gtbl
146.43
KB
-rwxr-xr-x
2023-03-07 09:38
gunzip
2.29
KB
-rwxr-xr-x
2022-04-10 02:22
gzexe
6.3
KB
-rwxr-xr-x
2022-04-10 02:22
gzip
95.84
KB
-rwxr-xr-x
2022-04-10 02:22
h2ph
28.54
KB
-rwxr-xr-x
2025-08-29 12:09
h2xs
59.51
KB
-rwxr-xr-x
2025-08-29 12:09
hardlink
50.39
KB
-rwxr-xr-x
2024-11-21 20:01
hd
58.32
KB
-rwxr-xr-x
2024-11-21 20:01
head
46.95
KB
-rwxr-xr-x
2022-09-20 15:27
helpztags
2.46
KB
-rwxr-xr-x
2025-02-16 05:23
hexdump
58.32
KB
-rwxr-xr-x
2024-11-21 20:01
hmm-assembler.pl
11.08
KB
-rwxr-xr-x
2013-11-30 07:54
hmm-info
118.62
KB
-rwxr-xr-x
2020-12-22 13:24
host
114.7
KB
-rwxr-xr-x
2026-07-31 21:11
hostid
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
hostname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
hostnamectl
30.38
KB
-rwxr-xr-x
2026-04-27 19:48
htcacheclean
34.24
KB
-rwxr-xr-x
2026-06-12 05:08
htdbm
26.23
KB
-rwxr-xr-x
2026-06-12 05:08
htdigest
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
html2text
214.17
KB
-rwxr-xr-x
2020-06-23 20:20
htpasswd
26.23
KB
-rwxr-xr-x
2026-06-12 05:08
i386
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
iconv
63.13
KB
-rwxr-xr-x
2026-04-27 20:14
id
47.02
KB
-rwxr-xr-x
2022-09-20 15:27
infocmp
62.31
KB
-rwxr-xr-x
2023-05-07 14:33
infotocap
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
innochecksum
4.51
MB
-rwxr-xr-x
2026-06-27 11:11
innotop
445.44
KB
-rwxr-xr-x
2026-06-27 11:11
install
155.8
KB
-rwxr-xr-x
2022-09-20 15:27
instmodsh
4.27
KB
-rwxr-xr-x
2025-08-29 12:09
ionice
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
ip
674.82
KB
-rwxr-xr-x
2023-05-22 13:19
ipcmk
34.38
KB
-rwxr-xr-x
2024-11-21 20:01
ipcrm
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
ipcs
74.31
KB
-rwxr-xr-x
2024-11-21 20:01
iptables-xml
88.98
KB
-rwxr-xr-x
2023-01-16 13:44
ischroot
14.32
KB
-rwxr-xr-x
2023-07-28 23:46
isodump
180.17
KB
-rwxr-xr-x
2022-06-24 14:56
isoinfo
343.42
KB
-rwxr-xr-x
2022-06-24 14:56
isovfy
184.14
KB
-rwxr-xr-x
2022-06-24 14:56
join
54.98
KB
-rwxr-xr-x
2022-09-20 15:27
journalctl
74.64
KB
-rwxr-xr-x
2026-04-27 19:48
json-patch-jsondiff
1004
B
-rwxr-xr-x
2021-09-29 10:31
json_pp
4.88
KB
-rwxr-xr-x
2025-08-29 12:09
json_xs
6.85
KB
-rwxr-xr-x
2025-09-08 20:30
jsondiff
1004
B
-rwxr-xr-x
2021-09-29 10:31
jsonpatch
3.77
KB
-rwxr-xr-x
2021-09-29 10:31
jsonpointer
1.79
KB
-rwxr-xr-x
2022-09-23 09:59
jsonschema
213
B
-rwxr-xr-x
2023-01-20 10:53
kbxutil
162.77
KB
-rwxr-xr-x
2026-01-01 14:54
kernel-install
12.75
KB
-rwxr-xr-x
2026-04-27 19:48
kill
22.3
KB
-rwxr-xr-x
2022-12-19 06:06
killall
31.95
KB
-rwxr-xr-x
2022-12-13 05:27
kmod
174.27
KB
-rwxr-xr-x
2022-12-10 00:02
last
50.31
KB
-rwxr-xr-x
2024-11-21 20:01
lastb
50.31
KB
-rwxr-xr-x
2024-11-21 20:01
lastlog
31.75
KB
-rwxr-xr-x
2025-12-14 14:00
lcf
7.6
KB
-rwxr-xr-x
2024-12-20 07:39
ld.so
209.96
KB
-rwxr-xr-x
2026-04-27 20:14
ldd
5.28
KB
-rwxr-xr-x
2026-04-27 20:14
less
194.3
KB
-rwxr-xr-x
2024-05-02 18:30
lessecho
14.24
KB
-rwxr-xr-x
2024-05-02 18:30
lessfile
8.83
KB
-rwxr-xr-x
2024-05-02 18:30
lesskey
23.63
KB
-rwxr-xr-x
2024-05-02 18:30
lesspipe
8.83
KB
-rwxr-xr-x
2024-05-02 18:30
lexgrog
107.48
KB
-rwxr-xr-x
2023-03-12 22:23
lft
2.43
KB
-rwxr-xr-x
2023-02-25 12:24
lft.db
2.43
KB
-rwxr-xr-x
2023-02-25 12:24
libnetcfg
15.41
KB
-rwxr-xr-x
2025-08-29 12:09
link
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
linux-check-removal
4.6
KB
-rwxr-xr-x
2025-05-25 15:54
linux-run-hooks
3.46
KB
-rwxr-xr-x
2026-06-08 20:53
linux-update-symlinks
6.38
KB
-rwxr-xr-x
2025-05-25 15:54
linux-version
2.67
KB
-rwxr-xr-x
2025-05-25 15:54
linux32
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
linux64
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
ln
71.12
KB
-rwxr-xr-x
2022-09-20 15:27
lnstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
locale
46.16
KB
-rwxr-xr-x
2026-04-27 20:14
localectl
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
localedef
291.91
KB
-rwxr-xr-x
2026-04-27 20:14
logger
54.9
KB
-rwxr-xr-x
2024-11-21 20:01
login
51.78
KB
-rwxr-xr-x
2025-12-14 14:00
loginctl
58.48
KB
-rwxr-xr-x
2026-04-27 19:48
logname
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
logresolve
14.24
KB
-rwxr-xr-x
2026-06-12 05:08
look
18.31
KB
-rwxr-xr-x
2024-11-21 20:01
ls
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
lsattr
14.24
KB
-rwxr-xr-x
2025-06-06 17:12
lsb_release
2.59
KB
-rwxr-xr-x
2022-09-26 20:06
lsblk
202.31
KB
-rwxr-xr-x
2024-11-21 20:01
lscpu
126.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsfd
120.3
KB
-rwxr-xr-x
2024-11-21 20:01
lsinitramfs
735
B
-rwxr-xr-x
2025-03-02 16:09
lsipc
98.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsirq
34.48
KB
-rwxr-xr-x
2024-11-21 20:01
lslocks
70.7
KB
-rwxr-xr-x
2024-11-21 20:01
lslogins
94.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsmem
66.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsmod
174.27
KB
-rwxr-xr-x
2022-12-10 00:02
lsns
82.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsof
175.61
KB
-rwxr-xr-x
2022-04-28 04:08
lspci
104.04
KB
-rwxr-xr-x
2023-01-17 23:50
lspgpot
1.06
KB
-rwxr-xr-x
2017-08-28 10:22
lynx
1.86
MB
-rwxr-xr-x
2023-01-15 14:21
lzcat
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
lzcmp
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
lzdiff
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
lzegrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzfgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzless
1.77
KB
-rwxr-xr-x
2026-06-26 13:13
lzma
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
lzmainfo
14.3
KB
-rwxr-xr-x
2026-06-26 13:13
lzmore
2.14
KB
-rwxr-xr-x
2026-06-26 13:13
mail
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
mail.mailutils
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
mailq
30.38
KB
-rwxr-xr-x
2024-03-06 15:10
mailx
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
man
121.36
KB
-rwxr-xr-x
2023-03-12 22:23
man-recode
35.38
KB
-rwxr-xr-x
2023-03-12 22:23
mandb
147.61
KB
-rwxr-xr-x
2023-03-12 22:23
manpath
34.78
KB
-rwxr-xr-x
2023-03-12 22:23
mariadb
4.98
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-access
109.31
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-admin
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-analyze
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-binlog
5.02
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-check
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-conv
4.5
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-convert-table-format
4.12
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-dump
4.85
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-dumpslow
8.05
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-find-rows
3.21
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-fix-extensions
1.22
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-hotcopy
34.53
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-import
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-install-db
22.13
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-optimize
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-plugin
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-repair
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-report
49.02
KB
-rwxr-xr-x
2025-02-10 17:26
mariadb-secure-installation
13.48
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-service-convert
2.45
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-setpermission
17.56
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-show
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-slap
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-tzinfo-to-sql
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-upgrade
4.91
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-waitpid
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
mariadbcheck
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-multi
26.69
KB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-safe
30.42
KB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-safe-helper
4.44
MB
-rwxr-xr-x
2026-06-27 11:11
markdown-it
220
B
-rwxr-xr-x
2023-03-31 10:50
mawk
154.66
KB
-rwxr-xr-x
2022-06-17 15:35
mc
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcdiff
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcedit
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcookie
34.38
KB
-rwxr-xr-x
2024-11-21 20:01
mcview
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
md5sum
50.95
KB
-rwxr-xr-x
2022-09-20 15:27
md5sum.textutils
50.95
KB
-rwxr-xr-x
2022-09-20 15:27
mesg
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
messages
14.6
KB
-rwxr-xr-x
2023-03-03 16:00
messages.mailutils
14.6
KB
-rwxr-xr-x
2023-03-03 16:00
migrate-pubring-from-classic-gpg
2.99
KB
-rwxr-xr-x
2025-12-31 17:32
mimeview
19.28
KB
-rwxr-xr-x
2023-03-03 16:00
mkdir
95.27
KB
-rwxr-xr-x
2022-09-20 15:27
mkfifo
67.17
KB
-rwxr-xr-x
2022-09-20 15:27
mkisofs
631.17
KB
-rwxr-xr-x
2022-06-24 14:56
mknod
71.2
KB
-rwxr-xr-x
2022-09-20 15:27
mksquashfs
263.9
KB
-rwxr-xr-x
2022-03-27 16:50
mktemp
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
mkzftree
30.84
KB
-rwxr-xr-x
2022-06-24 14:56
mokutil
60.27
KB
-rwxr-xr-x
2022-06-15 13:30
more
58.31
KB
-rwxr-xr-x
2024-11-21 20:01
mount
58.3
KB
-rwsr-xr-x
2024-11-21 20:01
mount-image-callback
13.86
KB
-rwxr-xr-x
2022-06-03 10:51
mountpoint
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
movemail
40.19
KB
-rwxr-xr-x
2023-03-03 16:00
movemail.mailutils
40.19
KB
-rwxr-xr-x
2023-03-03 16:00
msql2mysql
1.41
KB
-rwxr-xr-x
2026-06-27 11:11
mt
83.38
KB
-rwxr-xr-x
2022-09-14 19:45
mt-gnu
83.38
KB
-rwxr-xr-x
2022-09-14 19:45
mv
139.62
KB
-rwxr-xr-x
2022-09-20 15:27
my_print_defaults
4.47
MB
-rwxr-xr-x
2026-06-27 11:11
myisam_ftdump
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
myisamchk
4.87
MB
-rwxr-xr-x
2026-06-27 11:11
myisamlog
4.73
MB
-rwxr-xr-x
2026-06-27 11:11
myisampack
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mysql
4.98
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_convert_table_format
4.12
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_find_rows
3.21
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_fix_extensions
1.22
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_install_db
22.13
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_plugin
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_secure_installation
13.48
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_setpermission
17.56
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_tzinfo_to_sql
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_upgrade
4.91
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_waitpid
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlaccess
109.31
KB
-rwxr-xr-x
2026-06-27 11:11
mysqladmin
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlanalyze
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlbinlog
5.02
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlcheck
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqld_multi
26.69
KB
-rwxr-xr-x
2026-06-27 11:11
mysqld_safe
30.42
KB
-rwxr-xr-x
2026-06-27 11:11
mysqld_safe_helper
4.44
MB
-rwxr-xr-x
2026-06-27 11:11
mysqldump
4.85
MB
-rwxr-xr-x
2026-06-27 11:11
mysqldumpslow
8.05
KB
-rwxr-xr-x
2026-06-27 11:11
mysqlhotcopy
34.53
KB
-rwxr-xr-x
2026-06-27 11:11
mysqlimport
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mysqloptimize
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlrepair
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlreport
49.02
KB
-rwxr-xr-x
2025-02-10 17:26
mysqlshow
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlslap
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mytop
72.03
KB
-rwxr-xr-x
2026-06-27 11:11
namei
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
nano
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
nawk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
neqn
913
B
-rwxr-xr-x
2023-03-07 09:38
netstat
151.66
KB
-rwxr-xr-x
2025-05-26 19:27
networkctl
106.38
KB
-rwxr-xr-x
2026-04-27 19:48
newaliases
30.38
KB
-rwxr-xr-x
2024-03-06 15:10
newgrp
47.75
KB
-rwsr-xr-x
2025-12-14 14:00
ngettext
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
nice
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
nisdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
nl
111.11
KB
-rwxr-xr-x
2022-09-20 15:27
nohup
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
normalizer
244
B
-rwxr-xr-x
2022-11-27 08:00
nproc
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
nroff
3.22
KB
-rwxr-xr-x
2023-03-07 09:38
nsenter
34.54
KB
-rwxr-xr-x
2024-11-21 20:01
nstat
104.45
KB
-rwxr-xr-x
2023-05-22 13:19
numfmt
67.02
KB
-rwxr-xr-x
2022-09-20 15:27
od
79.02
KB
-rwxr-xr-x
2022-09-20 15:27
open
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
openssl
953.26
KB
-rwxr-xr-x
2026-06-06 19:56
pager
194.3
KB
-rwxr-xr-x
2024-05-02 18:30
partx
118.31
KB
-rwxr-xr-x
2024-11-21 20:01
passwd
66.65
KB
-rwsr-xr-x
2025-12-14 14:00
paste
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
patch-hmm.pl
580
B
-rwxr-xr-x
2013-11-30 07:54
pathchk
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
pdb3
62.4
KB
-rwxr-xr-x
2026-05-12 05:17
pdb3.11
62.4
KB
-rwxr-xr-x
2026-05-12 05:17
peekfd
14.5
KB
-rwxr-xr-x
2022-12-13 05:27
perl
3.63
MB
-rwxr-xr-x
2025-08-29 12:09
perl5.36-x86_64-linux-gnu
14.41
KB
-rwxr-xr-x
2025-08-29 12:09
perl5.36.0
3.63
MB
-rwxr-xr-x
2025-08-29 12:09
perlbug
44.12
KB
-rwxr-xr-x
2025-08-29 12:09
perldoc
125
B
-rwxr-xr-x
2025-08-16 18:03
perlivp
10.61
KB
-rwxr-xr-x
2025-08-29 12:09
perlthanks
44.12
KB
-rwxr-xr-x
2025-08-29 12:09
perror
4.66
MB
-rwxr-xr-x
2026-06-27 11:11
pgrep
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.default
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar.default
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar8.1
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar.phar8.3
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar.phar8.4
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar8.1
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar8.1.phar
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar8.3
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar8.3.phar
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar8.4
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar8.4.phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
php
5.3
MB
-rwxr-xr-x
2026-07-03 10:33
php.default
5.73
MB
-rwxr-xr-x
2026-07-03 10:04
php8.1
5.3
MB
-rwxr-xr-x
2026-07-03 10:33
php8.3
5.5
MB
-rwxr-xr-x
2026-07-08 19:13
php8.4
5.73
MB
-rwxr-xr-x
2026-07-03 10:04
pic
220.27
KB
-rwxr-xr-x
2023-03-07 09:38
pico
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
piconv
8.16
KB
-rwxr-xr-x
2025-08-29 12:09
pidof
26.31
KB
-rwxr-xr-x
2023-04-03 06:25
pidwait
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
pinentry
70.57
KB
-rwxr-xr-x
2022-10-18 14:52
pinentry-curses
70.57
KB
-rwxr-xr-x
2022-10-18 14:52
ping
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
ping4
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
ping6
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
pinky
47.05
KB
-rwxr-xr-x
2022-09-20 15:27
pkaction
18.23
KB
-rwxr-xr-x
2023-01-31 22:05
pkcheck
22.3
KB
-rwxr-xr-x
2023-01-31 22:05
pkill
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
pkttyagent
18.23
KB
-rwxr-xr-x
2023-01-31 22:05
pl2pm
4.43
KB
-rwxr-xr-x
2025-08-29 12:09
pldd
22.69
KB
-rwxr-xr-x
2026-04-27 20:14
pmap
34.34
KB
-rwxr-xr-x
2022-12-19 06:06
pod2html
4.04
KB
-rwxr-xr-x
2025-08-29 12:09
pod2man
14.68
KB
-rwxr-xr-x
2025-08-29 12:09
pod2text
10.55
KB
-rwxr-xr-x
2025-08-29 12:09
pod2usage
4.01
KB
-rwxr-xr-x
2025-08-29 12:09
podchecker
3.57
KB
-rwxr-xr-x
2025-08-29 12:09
pr
79.11
KB
-rwxr-xr-x
2022-09-20 15:27
preconv
66.43
KB
-rwxr-xr-x
2023-03-07 09:38
print
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
printenv
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
printf
62.92
KB
-rwxr-xr-x
2022-09-20 15:27
prlimit
38.83
KB
-rwxr-xr-x
2024-11-21 20:01
procan
79.91
KB
-rwxr-xr-x
2022-11-06 08:15
prove
13.34
KB
-rwxr-xr-x
2025-08-29 12:09
prtstat
18.57
KB
-rwxr-xr-x
2022-12-13 05:27
ps
142.93
KB
-rwxr-xr-x
2022-12-19 06:06
pslog
14.45
KB
-rwxr-xr-x
2022-12-13 05:27
pstree
35.78
KB
-rwxr-xr-x
2022-12-13 05:27
pstree.x11
35.78
KB
-rwxr-xr-x
2022-12-13 05:27
ptar
3.48
KB
-rwxr-xr-x
2025-08-29 12:09
ptardiff
2.58
KB
-rwxr-xr-x
2025-08-29 12:09
ptargrep
4.29
KB
-rwxr-xr-x
2025-08-29 12:09
ptx
135.23
KB
-rwxr-xr-x
2022-09-20 15:27
pv
63.98
KB
-rwxr-xr-x
2022-04-12 00:55
pwd
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
pwdx
14.3
KB
-rwxr-xr-x
2022-12-19 06:06
py3clean
7.63
KB
-rwxr-xr-x
2023-04-09 10:22
py3compile
13
KB
-rwxr-xr-x
2023-04-09 10:22
py3versions
12.52
KB
-rwxr-xr-x
2023-04-09 10:22
pydoc3
79
B
-rwxr-xr-x
2026-05-12 05:17
pydoc3.11
79
B
-rwxr-xr-x
2026-05-12 05:17
pygettext3
23.67
KB
-rwxr-xr-x
2023-02-07 13:37
pygettext3.11
23.67
KB
-rwxr-xr-x
2023-02-07 13:37
pygmentize
970
B
-rwxr-xr-x
2023-01-07 09:12
pyserial-miniterm
975
B
-rwxr-xr-x
2022-09-26 15:04
pyserial-ports
969
B
-rwxr-xr-x
2022-09-26 15:04
python3
6.52
MB
-rwxr-xr-x
2026-05-12 05:17
python3.11
6.52
MB
-rwxr-xr-x
2026-05-12 05:17
pzstd
742.38
KB
-rwxr-xr-x
2023-03-18 20:58
qemu-img
2.19
MB
-rwxr-xr-x
2026-05-25 20:44
qemu-io
2.14
MB
-rwxr-xr-x
2026-05-25 20:44
qemu-nbd
2.33
MB
-rwxr-xr-x
2026-05-25 20:44
qrencode
38.56
KB
-rwxr-xr-x
2020-12-22 05:31
querybts
10.64
KB
-rwxr-xr-x
2023-04-29 06:38
rbash
1.21
MB
-rwxr-xr-x
2026-05-07 20:33
rdma
180.6
KB
-rwxr-xr-x
2023-05-22 13:19
readlink
50.89
KB
-rwxr-xr-x
2022-09-20 15:27
readmsg
35.84
KB
-rwxr-xr-x
2023-03-03 16:00
readmsg.mailutils
35.84
KB
-rwxr-xr-x
2023-03-03 16:00
realpath
50.92
KB
-rwxr-xr-x
2022-09-20 15:27
rename.ul
22.3
KB
-rwxr-xr-x
2024-11-21 20:01
renice
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
replace
4.45
MB
-rwxr-xr-x
2026-06-27 11:11
reportbug
110.11
KB
-rwxr-xr-x
2023-04-29 06:38
reset
30.24
KB
-rwxr-xr-x
2023-05-07 14:33
resize-part-image
4.23
KB
-rwxr-xr-x
2022-06-03 10:51
resizepart
70.31
KB
-rwxr-xr-x
2024-11-21 20:01
resolve_stack_dump
4.47
MB
-rwxr-xr-x
2026-06-27 11:11
resolvectl
146.53
KB
-rwxr-xr-x
2026-04-27 19:48
resolveip
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
rev
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
rgrep
30
B
-rwxr-xr-x
2020-01-29 12:09
rm
71.05
KB
-rwxr-xr-x
2022-09-20 15:27
rmail
18.3
KB
-rwxr-xr-x
2024-03-06 15:10
rmdir
54.92
KB
-rwxr-xr-x
2022-09-20 15:27
rnano
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
rotatelogs
26.31
KB
-rwxr-xr-x
2026-06-12 05:08
routel
1.62
KB
-rwxr-xr-x
2023-05-22 13:19
rrsync
12.34
KB
-rwxr-xr-x
2026-05-24 21:23
rsync
514.35
KB
-rwxr-xr-x
2026-05-24 21:23
rsync-ssl
5.02
KB
-rwxr-xr-x
2026-05-24 21:23
rtstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
run-mailcap
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
run-parts
26.91
KB
-rwxr-xr-x
2023-07-28 23:46
runcon
42.95
KB
-rwxr-xr-x
2022-09-20 15:27
rview
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
rvim
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
savelog
10.24
KB
-rwxr-xr-x
2023-07-28 23:46
scp
266.63
KB
-rwxr-xr-x
2026-05-05 10:26
screen
471.09
KB
-rwxr-xr-x
2023-01-09 03:56
script
70.3
KB
-rwxr-xr-x
2024-11-21 20:01
scriptlive
54.3
KB
-rwxr-xr-x
2024-11-21 20:01
scriptreplay
46.3
KB
-rwxr-xr-x
2024-11-21 20:01
sdiff
55.08
KB
-rwxr-xr-x
2023-02-03 19:00
sed
123.46
KB
-rwxr-xr-x
2026-04-21 07:50
see
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
select-editor
2.39
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-browser
1.26
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-editor
1.24
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-pager
565
B
-rwxr-xr-x
2023-01-14 16:28
seq
58.92
KB
-rwxr-xr-x
2022-09-20 15:27
setarch
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
setpci
30.31
KB
-rwxr-xr-x
2023-01-17 23:50
setpriv
78.31
KB
-rwxr-xr-x
2024-11-21 20:01
setsid
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
setterm
46.31
KB
-rwxr-xr-x
2024-11-21 20:01
sftp
282.59
KB
-rwxr-xr-x
2026-05-05 10:26
sg
47.75
KB
-rwsr-xr-x
2025-12-14 14:00
sh
122.7
KB
-rwxr-xr-x
2023-01-05 13:20
sha1sum
54.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha224sum
58.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha256sum
58.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha384sum
62.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha512sum
62.95
KB
-rwxr-xr-x
2022-09-20 15:27
shasum
9.75
KB
-rwxr-xr-x
2025-08-29 12:09
shred
63.14
KB
-rwxr-xr-x
2022-09-20 15:27
shuf
58.98
KB
-rwxr-xr-x
2022-09-20 15:27
sieve
31.98
KB
-rwxr-xr-x
2023-03-03 16:00
skill
30.33
KB
-rwxr-xr-x
2022-12-19 06:06
slabtop
22.37
KB
-rwxr-xr-x
2022-12-19 06:06
sleep
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
slogin
1.08
MB
-rwxr-xr-x
2026-05-05 10:26
snap
14.79
MB
-rwxr-xr-x
2026-05-10 10:28
snap-hmm
56
B
-rwxr-xr-x
2020-08-18 08:47
snapctl
5.81
MB
-rwxr-xr-x
2026-05-10 10:28
snice
30.33
KB
-rwxr-xr-x
2022-12-19 06:06
socat
401.98
KB
-rwxr-xr-x
2022-11-06 08:15
soelim
50.43
KB
-rwxr-xr-x
2023-03-07 09:38
sort
115.68
KB
-rwxr-xr-x
2022-09-20 15:27
splain
18.99
KB
-rwxr-xr-x
2025-08-29 12:09
split
59.55
KB
-rwxr-xr-x
2022-09-20 15:27
sqfscat
141.37
KB
-rwxr-xr-x
2022-03-27 16:50
sqfstar
263.9
KB
-rwxr-xr-x
2022-03-27 16:50
ss
189.14
KB
-rwxr-xr-x
2023-05-22 13:19
ssh
1.08
MB
-rwxr-xr-x
2026-05-05 10:26
ssh-add
518.44
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-agent
474.38
KB
-rwxr-sr-x
2026-05-05 10:26
ssh-argv0
1.42
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-copy-id
12.38
KB
-rwxr-xr-x
2023-02-02 12:21
ssh-import-id
409
B
-rwxr-xr-x
2020-03-08 23:48
ssh-import-id-gh
785
B
-rwxr-xr-x
2020-02-28 15:44
ssh-import-id-lp
785
B
-rwxr-xr-x
2020-02-28 15:44
ssh-keygen
646.44
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-keyscan
622.47
KB
-rwxr-xr-x
2026-05-05 10:26
stat
95.2
KB
-rwxr-xr-x
2022-09-20 15:27
stdbuf
58.92
KB
-rwxr-xr-x
2022-09-20 15:27
streamzip
7.75
KB
-rwxr-xr-x
2025-08-29 12:09
stty
83.02
KB
-rwxr-xr-x
2022-09-20 15:27
su
70.31
KB
-rwsr-xr-x
2024-11-21 20:01
sudo
275.02
KB
-rwsr-xr-x
2026-04-11 12:01
sudoedit
275.02
KB
-rwsr-xr-x
2026-04-11 12:01
sudoreplay
115.7
KB
-rwxr-xr-x
2026-04-11 12:01
sum
50.96
KB
-rwxr-xr-x
2022-09-20 15:27
sync
38.89
KB
-rwxr-xr-x
2022-09-20 15:27
systemctl
1.29
MB
-rwxr-xr-x
2026-04-27 19:48
systemd
90.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-analyze
182.61
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-ask-password
18.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cat
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cgls
22.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cgtop
38.4
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-creds
42.61
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cryptenroll
58.6
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-delta
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-detect-virt
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-escape
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-firstboot
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-hwdb
126.66
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-id128
22.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-inhibit
22.39
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-machine-id-setup
18.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-mount
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-notify
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-path
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-repart
150.69
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-run
58.57
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-socket-activate
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-stdio-bridge
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-sysext
42.49
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-sysusers
62.68
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-tmpfiles
110.57
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-tty-ask-password-agent
34.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-umount
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
tabs
18.23
KB
-rwxr-xr-x
2023-05-07 14:33
tac
111.05
KB
-rwxr-xr-x
2022-09-20 15:27
tail
75.14
KB
-rwxr-xr-x
2022-09-20 15:27
tar
519.52
KB
-rwxr-xr-x
2024-01-20 09:27
taskset
62.31
KB
-rwxr-xr-x
2024-11-21 20:01
tbl
146.43
KB
-rwxr-xr-x
2023-03-07 09:38
tcpdump
1.21
MB
-rwxr-xr-x
2023-01-14 17:23
tee
42.95
KB
-rwxr-xr-x
2022-09-20 15:27
tempfile
14.18
KB
-rwxr-xr-x
2023-07-28 23:46
test
58.89
KB
-rwxr-xr-x
2022-09-20 15:27
tic
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
timedatectl
42.37
KB
-rwxr-xr-x
2026-04-27 19:48
timeout
47.49
KB
-rwxr-xr-x
2022-09-20 15:27
tload
18.32
KB
-rwxr-xr-x
2022-12-19 06:06
toe
22.23
KB
-rwxr-xr-x
2023-05-07 14:33
top
131.58
KB
-rwxr-xr-x
2022-12-19 06:06
touch
107.05
KB
-rwxr-xr-x
2022-09-20 15:27
tput
26.27
KB
-rwxr-xr-x
2023-05-07 14:33
tr
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
traceproto
2.82
KB
-rwxr-xr-x
2023-02-25 12:24
traceproto.db
2.82
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute-nanog
1.58
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute.db
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute6
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute6.db
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
troff
755.83
KB
-rwxr-xr-x
2023-03-07 09:38
true
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
truncate
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
tset
30.24
KB
-rwxr-xr-x
2023-05-07 14:33
tsort
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
tty
34.86
KB
-rwxr-xr-x
2022-09-20 15:27
tzselect
14.99
KB
-rwxr-xr-x
2026-04-27 20:14
ubuntu-cloudimg-query
8.37
KB
-rwxr-xr-x
2022-06-03 10:51
ubuntu-core-launcher
112.1
KB
-rwsr-xr-x
2026-05-10 10:28
ucf
40.69
KB
-rwxr-xr-x
2024-12-20 07:39
ucfq
18.91
KB
-rwxr-xr-x
2024-12-20 07:39
ucfr
10.85
KB
-rwxr-xr-x
2024-12-20 07:39
uclampset
62.31
KB
-rwxr-xr-x
2024-11-21 20:01
udevadm
1.29
MB
-rwxr-xr-x
2026-04-27 19:48
ul
22.31
KB
-rwxr-xr-x
2024-11-21 20:01
umount
34.3
KB
-rwsr-xr-x
2024-11-21 20:01
uname
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
unattended-upgrade
97.21
KB
-rwxr-xr-x
2022-12-31 20:59
unattended-upgrades
97.21
KB
-rwxr-xr-x
2022-12-31 20:59
uncompress
2.29
KB
-rwxr-xr-x
2022-04-10 02:22
unexpand
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
uniq
46.95
KB
-rwxr-xr-x
2022-09-20 15:27
unlink
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
unlzma
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
unmkinitramfs
3.59
KB
-rwxr-xr-x
2025-04-24 15:40
unshare
82.54
KB
-rwxr-xr-x
2024-11-21 20:01
unsquashfs
141.37
KB
-rwxr-xr-x
2022-03-27 16:50
unxz
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
unzip
175.05
KB
-rwxr-xr-x
2026-08-16 13:50
unzipsfx
82.86
KB
-rwxr-xr-x
2026-08-16 13:50
unzstd
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
update-alternatives
58.31
KB
-rwxr-xr-x
2026-03-07 12:15
update-mime-database
59.27
KB
-rwxr-xr-x
2022-04-29 17:19
uptime
14.3
KB
-rwxr-xr-x
2022-12-19 06:06
users
38.89
KB
-rwxr-xr-x
2022-09-20 15:27
utmpdump
30.3
KB
-rwxr-xr-x
2024-11-21 20:01
uuidgen
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
uuidparse
42.31
KB
-rwxr-xr-x
2024-11-21 20:01
vcs-run
6.75
KB
-rwxr-xr-x
2022-06-03 10:51
vdir
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
vi
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
view
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim.basic
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim.tiny
1.55
MB
-rwxr-xr-x
2025-02-16 05:23
vimdiff
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vimtutor
2.1
KB
-rwxr-xr-x
2025-02-16 05:23
vmstat
34.72
KB
-rwxr-xr-x
2022-12-19 06:06
w
22.3
KB
-rwxr-xr-x
2022-12-19 06:06
wall
38.3
KB
-rwxr-xr-x
2024-11-21 20:01
watch
26.71
KB
-rwxr-xr-x
2022-12-19 06:06
watchgnupg
18.23
KB
-rwxr-xr-x
2026-01-01 14:54
wc
51.05
KB
-rwxr-xr-x
2022-09-20 15:27
wdctl
70.34
KB
-rwxr-xr-x
2024-11-21 20:01
webmin
13.29
KB
-rwxr-xr-x
2026-07-17 21:17
wget
459.36
KB
-rwxr-xr-x
2025-03-03 13:32
whatis
51.29
KB
-rwxr-xr-x
2023-03-12 22:23
whereis
30.77
KB
-rwxr-xr-x
2024-11-21 20:01
which
946
B
-rwxr-xr-x
2023-07-28 23:46
which.debianutils
946
B
-rwxr-xr-x
2023-07-28 23:46
whiptail
26.75
KB
-rwxr-xr-x
2023-01-31 14:53
who
59.02
KB
-rwxr-xr-x
2022-09-20 15:27
whoami
38.86
KB
-rwxr-xr-x
2022-09-20 15:27
write
22.31
KB
-rwxr-xr-x
2024-11-21 20:01
write-mime-multipart
3.54
KB
-rwxr-xr-x
2022-06-03 10:51
wsrep_sst_backup
2.39
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_common
67.46
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_mariabackup
49.28
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_mysqldump
8.11
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_rsync
29.92
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_rsync_wan
29.92
KB
-rwxr-xr-x
2026-06-27 11:11
www-browser
1.86
MB
-rwxr-xr-x
2023-01-15 14:21
x86_64
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
xargs
70.45
KB
-rwxr-xr-x
2023-01-08 18:07
xsubpp
5.05
KB
-rwxr-xr-x
2025-08-29 12:09
xz
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
xzcat
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
xzcmp
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
xzdiff
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
xzegrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzfgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzless
1.77
KB
-rwxr-xr-x
2026-06-26 13:13
xzmore
2.14
KB
-rwxr-xr-x
2026-06-26 13:13
yes
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
ypdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
zcat
1.94
KB
-rwxr-xr-x
2022-04-10 02:22
zcmp
1.64
KB
-rwxr-xr-x
2022-04-10 02:22
zdiff
6.31
KB
-rwxr-xr-x
2022-04-10 02:22
zdump
22.52
KB
-rwxr-xr-x
2026-04-27 20:14
zegrep
29
B
-rwxr-xr-x
2022-04-10 02:22
zff2gff3.pl
684
B
-rwxr-xr-x
2013-11-30 07:54
zfgrep
29
B
-rwxr-xr-x
2022-04-10 02:22
zforce
2.03
KB
-rwxr-xr-x
2022-04-10 02:22
zgrep
7.91
KB
-rwxr-xr-x
2022-04-10 02:22
zipdetails
68.55
KB
-rwxr-xr-x
2025-08-29 12:09
zipgrep
2.89
KB
-rwxr-xr-x
2026-08-16 13:50
zipinfo
175.05
KB
-rwxr-xr-x
2026-08-16 13:50
zless
2.15
KB
-rwxr-xr-x
2022-04-10 02:22
zmore
1.8
KB
-rwxr-xr-x
2022-04-10 02:22
znew
4.47
KB
-rwxr-xr-x
2022-04-10 02:22
zoe-loop
126.62
KB
-rwxr-xr-x
2020-12-22 13:24
zstd
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
zstdcat
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
zstdgrep
3.78
KB
-rwxr-xr-x
2023-03-18 20:58
zstdless
197
B
-rwxr-xr-x
2023-03-18 20:58
zstdmt
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
Save
Rename
#!/usr/bin/env bash set -ue # Copyright (C) 2017-2024 MariaDB # Copyright (C) 2013 Percona Inc # # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation; version 2 of the License. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program; see the file COPYING. If not, write to the # Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston # MA 02110-1335 USA. # This is a reference script for mariadb-backup-based state snapshot transfer. # Documentation: # https://mariadb.com/kb/en/mariabackup-overview/ # Make sure to read that before proceeding! . $(dirname "$0")/wsrep_sst_common BACKUP_BIN=$(commandex 'mariadb-backup') if [ -z "$BACKUP_BIN" ]; then wsrep_log_error 'mariadb-backup binary not found in path' exit 42 fi BACKUP_PID="" INFO_FILE='xtrabackup_galera_info' DONOR_INFO_FILE='donor_galera_info' IST_FILE='xtrabackup_ist' MAGIC_FILE="$DATA/$INFO_FILE" DONOR_MAGIC_FILE="$DATA/$DONOR_INFO_FILE" ealgo="" eformat="" ekey="" ekeyfile="" encrypt=0 ssyslog="" ssystag="" tcert="" tcap="" tpem="" tkey="" tmode="" sockopt="" progress="" ttime=0 totime=0 lsn="" ecmd="" rlimit="" # Initially stagemsg="$WSREP_SST_OPT_ROLE" cpat="" speciald=1 ib_home_dir="" ib_log_dir="" ib_undo_dir="" ar_log_dir="" sfmt="" strmcmd="" tfmt="" tcmd="" payload=0 pvformat="-F '%N => Rate:%r Avg:%a Elapsed:%t %e Bytes: %b %p'" pvopts="-f -i 10 -N $WSREP_SST_OPT_ROLE" uextra=0 disver="" STATDIR="" tmpopts="" itmpdir="" xtmpdir="" scomp="" sdecomp="" ssl_dhparams="" compress='none' compress_chunk="" compress_threads="" backup_threads="" encrypt_threads="" encrypt_chunk="" readonly SECRET_TAG='secret' readonly TOTAL_TAG='total' # Required for backup locks # For backup locks it is 1 sent by joiner sst_ver=1 INNOAPPLYLOG="$DATA/mariabackup.prepare.log" INNOMOVELOG="$DATA/mariabackup.move.log" INNOBACKUPLOG="$DATA/mariabackup.backup.log" timeit() { local stage="$1" shift local cmd="$@" local x1 x2 took extcode if [ $ttime -eq 1 ]; then x1=$(date +%s) fi wsrep_log_info "Evaluating $cmd" eval $cmd extcode=$? if [ $ttime -eq 1 ]; then x2=$(date +%s) took=$(( x2-x1 )) wsrep_log_info "NOTE: $stage took $took seconds" totime=$(( totime+took )) fi return $extcode } get_keys() { # $encrypt -eq 1 is for internal purposes only if [ $encrypt -ge 2 -o $encrypt -eq -1 ]; then return fi if [ $encrypt -eq 0 ]; then if [ -n "$ealgo" -o -n "$ekey" -o -n "$ekeyfile" ]; then wsrep_log_error "Options for encryption are specified," \ "but encryption itself is disabled. SST may fail." fi return fi if [ "$sfmt" = 'tar' ]; then wsrep_log_info "NOTE: key-based encryption (encrypt=1)" \ "cannot be enabled with tar format" encrypt=-1 return fi wsrep_log_info "Key based encryption enabled in my.cnf" if [ -z "$ealgo" ]; then wsrep_log_error "FATAL: Encryption algorithm empty from my.cnf, bailing out" exit 3 fi if [ -z "$ekey" -a ! -r "$ekeyfile" ]; then wsrep_log_error "FATAL: Either key must be specified" \ "or keyfile must be readable" exit 3 fi if [ "$eformat" = 'openssl' ]; then get_openssl if [ -z "$OPENSSL_BINARY" ]; then wsrep_log_error "If encryption using the openssl is enabled," \ "then you need to install openssl" exit 2 fi ecmd="'$OPENSSL_BINARY' enc -$ealgo" if "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-pbkdf2'; then ecmd="$ecmd -pbkdf2" elif "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-iter'; then ecmd="$ecmd -iter 1" elif "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-md'; then ecmd="$ecmd -md sha256" fi if [ -z "$ekey" ]; then ecmd="$ecmd -kfile '$ekeyfile'" else ecmd="$ecmd -k '$ekey'" fi elif [ "$eformat" = 'xbcrypt' ]; then if [ -z "$(commandex xbcrypt)" ]; then wsrep_log_error "If encryption using the xbcrypt is enabled," \ "then you need to install xbcrypt" exit 2 fi wsrep_log_info "NOTE: xbcrypt-based encryption," \ "supported only from Xtrabackup 2.1.4" if [ -z "$ekey" ]; then ecmd="xbcrypt --encrypt-algo='$ealgo' --encrypt-key-file='$ekeyfile'" else ecmd="xbcrypt --encrypt-algo='$ealgo' --encrypt-key='$ekey'" fi if [ -n "$encrypt_threads" ]; then ecmd="$ecmd --encrypt-threads=$encrypt_threads" fi if [ -n "$encrypt_chunk" ]; then ecmd="$ecmd --encrypt-chunk-size=$encrypt_chunk" fi else wsrep_log_error "Unknown encryption format='$eformat'" exit 2 fi [ "$WSREP_SST_OPT_ROLE" = 'joiner' ] && ecmd="$ecmd -d" stagemsg="$stagemsg-XB-Encrypted" } get_socat_ver() { [ -n "${SOCAT_VERSION+x}" ] && return # Determine the socat version SOCAT_VERSION=$(socat -V 2>&1 | \ grep -m1 -owE '[0-9]+(\.[0-9]+)+' | \ head -n1 || :) if [ -z "$SOCAT_VERSION" ]; then wsrep_log_error "******** FATAL ERROR ******************" wsrep_log_error "* Cannot determine the socat version. *" wsrep_log_error "***************************************" exit 2 fi } get_transfer() { if [ "$tfmt" = 'nc' ]; then wsrep_log_info "Using netcat as streamer" wsrep_check_programs nc tcmd='nc' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then if nc -h 2>&1 | grep -q -F 'ncat'; then wsrep_log_info "Using Ncat as streamer" tcmd="$tcmd -l" elif nc -h 2>&1 | grep -qw -F -- '-d'; then wsrep_log_info "Using Debian netcat as streamer" tcmd="$tcmd -dl" if [ $WSREP_SST_OPT_HOST_IPv6 -eq 1 ]; then # When host is not explicitly specified (when only the port # is specified) netcat can only bind to an IPv4 address if # the "-6" option is not explicitly specified: tcmd="$tcmd -6" fi else wsrep_log_info "Using traditional netcat as streamer" tcmd="$tcmd -l -p" fi tcmd="$tcmd $SST_PORT" else # Check to see if netcat supports the '-N' flag. # -N Shutdown the network socket after EOF on stdin # If it supports the '-N' flag, then we need to use the '-N' # flag, otherwise the transfer will stay open after the file # transfer and cause the command to timeout. # Older versions of netcat did not need this flag and will # return an error if the flag is used. if nc -h 2>&1 | grep -qw -F -- '-N'; then tcmd="$tcmd -N" wsrep_log_info "Using nc -N" fi # netcat doesn't understand [] around IPv6 address if nc -h 2>&1 | grep -q -F 'ncat'; then wsrep_log_info "Using Ncat as streamer" elif nc -h 2>&1 | grep -qw -F -- '-d'; then wsrep_log_info "Using Debian netcat as streamer" else wsrep_log_info "Using traditional netcat as streamer" tcmd="$tcmd -q0" fi tcmd="$tcmd $(safe WSREP_SST_OPT_HOST_UNESCAPED) $SST_PORT" fi else tfmt='socat' wsrep_log_info "Using socat as streamer" wsrep_check_programs socat if [ -n "$sockopt" ]; then sockopt=$(trim_string "$sockopt" ',') if [ -n "$sockopt" ]; then sockopt=",$sockopt" fi fi # Add an option for ipv6 if needed: if [ $WSREP_SST_OPT_HOST_IPv6 -eq 1 ]; then # If sockopt contains 'pf=ip6' somewhere in the middle, # this will not interfere with socat, but exclude the trivial # cases when sockopt contains 'pf=ip6' as prefix or suffix: if [ "$sockopt" = "${sockopt#,pf=ip6,}" -a \ "$sockopt" = "${sockopt%,pf=ip6}" ] then sockopt=",pf=ip6$sockopt" fi fi if [ $encrypt -lt 2 ]; then if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="socat -u TCP-LISTEN:$SST_PORT,reuseaddr$sockopt stdio" else tcmd="socat -u stdio TCP:$REMOTEIP:$SST_PORT$sockopt" fi return fi if ! socat -V | grep -q -F 'WITH_OPENSSL 1'; then wsrep_log_error "******** FATAL ERROR ************************************************ " wsrep_log_error "* Encryption requested, but socat is not OpenSSL enabled (encrypt=$encrypt) *" wsrep_log_error "********************************************************************* " exit 2 fi local action='Decrypting' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="socat -u openssl-listen:$SST_PORT,reuseaddr" else local addr="$REMOTEIP:$SST_PORT" tcmd="socat -u stdio openssl-connect:$addr" action='Encrypting' get_socat_ver if ! check_for_version "$SOCAT_VERSION" '1.7.4.1'; then if check_for_version "$SOCAT_VERSION" '1.7.3.3'; then # Workaround for a bug known as 'Red Hat issue 1870279' # (connection reset by peer) in socat versions 1.7.3.3 # to 1.7.4.0: tcmd="socat stdio openssl-connect:$addr,linger=10" wsrep_log_info \ "Use workaround for socat $SOCAT_VERSION bug" fi fi if check_for_version "$SOCAT_VERSION" '1.7.4'; then tcmd="$tcmd,no-sni=1" fi fi if [ "${sockopt#*,dhparam=}" = "$sockopt" ]; then if [ -z "$ssl_dhparams" ]; then get_socat_ver if ! check_for_version "$SOCAT_VERSION" '1.7.3'; then # socat versions < 1.7.3 will have 512-bit dhparams (too small) # so create 2048-bit dhparams and send that as a parameter: check_for_dhparams fi fi if [ -n "$ssl_dhparams" ]; then tcmd="$tcmd,dhparam='$ssl_dhparams'" fi fi CN_option=",commonname=''" if [ $encrypt -eq 2 ]; then wsrep_log_info \ "Using openssl based encryption with socat: with crt and pem" if [ -z "$tpem" -o -z "$tcert$tcap" ]; then wsrep_log_error \ "Both PEM file and CRT file (or path) are required" exit 22 fi verify_ca_matches_cert "$tpem" "$tcert" "$tcap" tcmd="$tcmd,cert='$tpem'" if [ -n "$tcert" ]; then tcmd="$tcmd,cafile='$tcert'" fi if [ -n "$tcap" ]; then tcmd="$tcmd,capath='$tcap'" fi stagemsg="$stagemsg-OpenSSL-Encrypted-2" wsrep_log_info "$action with cert='$tpem', ca='$tcert', capath='$tcap'" elif [ $encrypt -eq 3 -o $encrypt -eq 4 ]; then wsrep_log_info \ "Using openssl based encryption with socat: with key and crt" if [ -z "$tpem" -o -z "$tkey" ]; then wsrep_log_error "Both the certificate file (or path) and" \ "the key file are required" exit 22 fi verify_cert_matches_key "$tpem" "$tkey" stagemsg="$stagemsg-OpenSSL-Encrypted-3" if [ -z "$tcert$tcap" ]; then if [ $encrypt -eq 4 ]; then wsrep_log_error \ "Peer certificate file (or path) required if encrypt=4" exit 22 fi # no verification CN_option="" tcmd="$tcmd,cert='$tpem',key='$tkey',verify=0" wsrep_log_info \ "$action with cert='$tpem', key='$tkey', verify=0" else # CA verification verify_ca_matches_cert "$tpem" "$tcert" "$tcap" if [ -n "$WSREP_SST_OPT_REMOTE_USER" ]; then CN_option=",commonname='$(safe WSREP_SST_OPT_REMOTE_USER)'" elif [ "$WSREP_SST_OPT_ROLE" = 'joiner' -o $encrypt -eq 4 ] then CN_option=",commonname=''" elif is_local_ip "$WSREP_SST_OPT_HOST_UNESCAPED"; then CN_option=',commonname=localhost' else CN_option=",commonname='$(safe WSREP_SST_OPT_HOST_UNESCAPED)'" fi tcmd="$tcmd,cert='$tpem',key='$tkey'" if [ -n "$tcert" ]; then tcmd="$tcmd,cafile='$tcert'" fi if [ -n "$tcap" ]; then tcmd="$tcmd,capath='$tcap'" fi wsrep_log_info "$action with cert='$tpem', key='$tkey'," \ "ca='$tcert', capath='$tcap'" fi else wsrep_log_info "Unknown encryption mode: encrypt=$encrypt" exit 22 fi tcmd="$tcmd$CN_option$sockopt" if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="$tcmd stdio" fi fi } get_footprint() { cd "$DATA_DIR" local payload_data if [ "$OS" = 'Linux' ]; then payload_data=$(find $findopt . \ -regex '.*undo[0-9]+$\|.*\.ibd$\|.*\.MYI$\|.*\.MYD$\|.*ibdata1$' \ -type f -print0 | du --files0-from=- --bytes -c -s | \ awk 'END { print $1 }') else payload_data=$(find $findopt . \ -regex '.*undo[0-9]+$|.*\.ibd$|.*\.MYI$\.*\.MYD$|.*ibdata1$' \ -type f -print0 | xargs -0 stat -f '%z' | \ awk '{ sum += $1 } END { print sum }') fi local payload_undo=0 if [ -n "$ib_undo_dir" -a "$ib_undo_dir" != '.' -a \ "$ib_undo_dir" != "$DATA_DIR" -a -d "$ib_undo_dir" ] then cd "$ib_undo_dir" if [ "$OS" = 'Linux' ]; then payload_undo=$(find . -regex '.*undo[0-9]+$' -type f -print0 | \ du --files0-from=- --bytes -c -s | awk 'END { print $1 }') else payload_undo=$(find . -regex '.*undo[0-9]+$' -type f -print0 | \ xargs -0 stat -f '%z' | awk '{ sum += $1 } END { print sum }') fi fi cd "$OLD_PWD" wsrep_log_info \ "SST footprint estimate: data: $payload_data, undo: $payload_undo" payload=$(( payload_data+payload_undo )) if [ "$compress" != 'none' ]; then # QuickLZ has around 50% compression ratio # When compression/compaction used, the progress is only an approximate. payload=$(( payload*1/2 )) fi if [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # report to parent the total footprint of the SST echo "$TOTAL_TAG $payload" fi adjust_progress } adjust_progress() { pcmd="" rcmd="" [ "$progress" = 'none' ] && return rlimitopts="" if [ -n "$rlimit" -a "$WSREP_SST_OPT_ROLE" = 'donor' ]; then wsrep_log_info "Rate-limiting SST to $rlimit" rlimitopts=" -L $rlimit" fi if [ -n "$progress" ]; then # Backward compatibility: user-configured progress output pcmd="pv $pvopts$rlimitopts" if [ -z "${PV_FORMAT+x}" ]; then PV_FORMAT=0 pv --help | grep -qw -F -- '-F' && PV_FORMAT=1 fi if [ $PV_FORMAT -eq 1 ]; then pcmd="$pcmd $pvformat" fi if [ $payload -ne 0 ]; then pcmd="$pcmd -s $payload" fi if [ "$progress" != '1' ]; then if [ -e "$progress" ]; then pcmd="$pcmd 2>>'$progress'" else pcmd="$pcmd 2>'$progress'" fi fi elif [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # Default progress output parseable by parent pcmd="pv -f -i 1 -n -b$rlimitopts" # read progress data, add tag and post to stdout # for the parent rcmd="stdbuf -oL tr '\r' '\n' | xargs -n1 echo complete" elif [ -n "$rlimitopts" ]; then # Rate-limiting only, when rlimit is non-zero pcmd="pv -q$rlimitopts" fi } bkgroups='sst|xtrabackup|mariabackup' encgroups="--mysqld|$bkgroups" read_cnf() { sfmt=$(parse_cnf sst streamfmt 'mbstream') tfmt=$(parse_cnf sst transferfmt 'socat') encrypt=$(parse_cnf "$encgroups" 'encrypt' 0) tmode=$(parse_cnf "$encgroups" 'ssl-mode' 'DISABLED' | \ tr '[[:lower:]]' '[[:upper:]]') case "$tmode" in 'VERIFY_IDENTITY'|'VERIFY_CA'|'REQUIRED'|'DISABLED') ;; *) wsrep_log_error "Unrecognized ssl-mode option: '$tmode'" exit 22 # EINVAL ;; esac if [ $encrypt -eq 0 -o $encrypt -ge 2 ]; then if [ "$tmode" != 'DISABLED' -o $encrypt -ge 2 ]; then check_server_ssl_config fi if [ "$tmode" != 'DISABLED' ]; then if [ 0 -eq $encrypt -a -n "$tpem" -a -n "$tkey" ] then encrypt=3 # enable cert/key SSL encyption # avoid CA verification if not set explicitly: # nodes may happen to have different CA if self-generated, # zeroing up tcert and tcap does the trick: if [ "${tmode#VERIFY}" = "$tmode" ]; then tcert="" tcap="" fi fi fi elif [ $encrypt -eq 1 ]; then ealgo=$(parse_cnf "$encgroups" 'encrypt-algo') eformat=$(parse_cnf "$encgroups" 'encrypt-format' 'openssl') ekey=$(parse_cnf "$encgroups" 'encrypt-key') # The keyfile should be read only when the key # is not specified or empty: if [ -z "$ekey" ]; then ekeyfile=$(parse_cnf "$encgroups" 'encrypt-key-file') fi fi wsrep_log_info "SSL configuration: CA='$tcert', CAPATH='$tcap'," \ "CERT='$tpem', KEY='$tkey', MODE='$tmode'," \ "encrypt='$encrypt'" if [ $encrypt -ge 2 ]; then ssl_dhparams=$(parse_cnf "$encgroups" 'ssl-dhparams') fi sockopt=$(parse_cnf sst sockopt) progress=$(parse_cnf sst progress) ttime=$(parse_cnf sst time 0) cpat='.*\.pem$\|.*galera\.cache$\|.*sst_in_progress$\|.*\.sst$\|.*gvwstate\.dat$\|.*grastate\.dat$\|.*\.err$\|.*\.log$\|.*RPM_UPGRADE_MARKER$\|.*RPM_UPGRADE_HISTORY$' [ "$OS" = 'FreeBSD' ] && cpat=$(echo "$cpat" | sed 's/\\|/|/g') cpat=$(parse_cnf sst cpat "$cpat") scomp=$(parse_cnf sst compressor) sdecomp=$(parse_cnf sst decompressor) rlimit=$(parse_cnf sst rlimit) uextra=$(parse_cnf sst use-extra 0) speciald=$(parse_cnf sst 'sst-special-dirs' 1) iopts=$(parse_cnf "$bkgroups" 'inno-backup-opts') iapts=$(parse_cnf "$bkgroups" 'inno-apply-opts') impts=$(parse_cnf "$bkgroups" 'inno-move-opts') use_memory=$(parse_cnf "$bkgroups" 'use-memory') if [ -z "$use_memory" ]; then if [ -n "$INNODB_BUFFER_POOL_SIZE" ]; then use_memory="$INNODB_BUFFER_POOL_SIZE" else use_memory=$(parse_cnf '--mysqld' 'innodb-buffer-pool-size') fi fi stimeout=$(parse_cnf sst 'sst-initial-timeout' 300) ssyslog=$(parse_cnf sst 'sst-syslog' 0) ssystag=$(parse_cnf mysqld_safe 'syslog-tag' "${SST_SYSLOG_TAG:-}") ssystag="$ssystag-" sstlogarchive=$(parse_cnf sst 'sst-log-archive' 1) sstlogarchivedir="" if [ $sstlogarchive -ne 0 ]; then sstlogarchivedir=$(parse_cnf sst sst-log-archive-dir \ '/tmp/sst_log_archive') if [ -n "$sstlogarchivedir" ]; then sstlogarchivedir=$(trim_dir "$sstlogarchivedir") fi fi if [ $speciald -eq 0 ]; then wsrep_log_error \ "sst-special-dirs equal to 0 is not supported, falling back to 1" speciald=1 fi if [ $ssyslog -ne -1 ]; then ssyslog=$(in_config 'mysqld_safe' 'syslog') fi if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then compress=$(parse_cnf "$encgroups" 'compress' 'none') if [ "$compress" != 'none' ]; then compress_chunk=$(parse_cnf "$encgroups" 'compress-chunk-size') compress_threads=$(parse_cnf "$encgroups" 'compress-threads') fi fi backup_threads=$(parse_cnf "$encgroups" 'backup-threads') if [ "$eformat" = 'xbcrypt' ]; then encrypt_threads=$(parse_cnf "$encgroups" 'encrypt-threads') encrypt_chunk=$(parse_cnf "$encgroups" 'encrypt-chunk-size') fi } get_stream() { if [ "$sfmt" = 'mbstream' -o "$sfmt" = 'xbstream' ]; then sfmt='mbstream' local STREAM_BIN=$(commandex "$sfmt") if [ -z "$STREAM_BIN" ]; then wsrep_log_error "Streaming with $sfmt, but $sfmt not found in path" exit 42 fi if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then strmcmd="'$STREAM_BIN' -x" else strmcmd="'$STREAM_BIN' -c '$INFO_FILE' '$DONOR_INFO_FILE'" fi else sfmt='tar' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then strmcmd='tar xfi -' else strmcmd="tar cf - '$INFO_FILE' '$DONOR_INFO_FILE'" fi fi wsrep_log_info "Streaming with $sfmt" } cleanup_at_exit() { # Since this is invoked just after exit NNN local estatus=$? if [ $estatus -ne 0 ]; then wsrep_log_error "Cleanup after exit with status: $estatus" elif [ -z "${coords:-}" -a "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then estatus=32 wsrep_log_error "Failed to get current position" fi [ "$(pwd)" != "$OLD_PWD" ] && cd "$OLD_PWD" if [ "$WSREP_SST_OPT_ROLE" = 'donor' -o $estatus -ne 0 ]; then if [ $estatus -ne 0 ]; then wsrep_log_error "Removing $MAGIC_FILE file due to signal" fi [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" || : [ -f "$DONOR_MAGIC_FILE" ] && rm -f "$DONOR_MAGIC_FILE" || : [ -f "$DATA/$IST_FILE" ] && rm -f "$DATA/$IST_FILE" || : fi if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then if [ -n "$BACKUP_PID" ]; then if ps -p $BACKUP_PID >/dev/null 2>&1; then wsrep_log_error \ "SST streaming process is still running. Killing..." cleanup_pid $BACKUP_PID fi fi wsrep_log_info "Removing the sst_in_progress file" wsrep_cleanup_progress_file fi if [ -n "$progress" -a -p "$progress" ]; then wsrep_log_info "Cleaning up fifo file: $progress" rm -f "$progress" || : fi wsrep_log_info "Cleaning up temporary directories" if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then [ -n "$STATDIR" -a -d "$STATDIR" ] && rm -rf "$STATDIR" || : else [ -n "$xtmpdir" -a -d "$xtmpdir" ] && rm -rf "$xtmpdir" || : [ -n "$itmpdir" -a -d "$itmpdir" ] && rm -rf "$itmpdir" || : fi # Final cleanup local pgid=$(ps -o 'pgid=' $$ 2>/dev/null | grep -o -E '[0-9]+' || :) # This means no setsid done in mysqld. # We don't want to kill mysqld here otherwise. if [ -n "$pgid" ]; then if [ $$ -eq $pgid ]; then # This means a signal was delivered to the process. # So, more cleanup. if [ $estatus -ge 128 ]; then kill -KILL -- -$$ || : fi fi fi if [ -n "$SST_PID" ]; then [ -f "$SST_PID" ] && rm -f "$SST_PID" || : fi exit $estatus } setup_ports() { SST_PORT="$(safe WSREP_SST_OPT_PORT)" if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then REMOTEIP="$(safe WSREP_SST_OPT_HOST)" lsn="$(safe WSREP_SST_OPT_LSN)" sst_ver="$(safe WSREP_SST_OPT_SST_VER)" fi } # # Waits ~30 seconds for socat or nc to open the port and # then reports ready, regardless of timeout. # wait_for_listen() { for i in {1..150}; do if check_port "" "$SST_PORT" 'socat|nc|netcat'; then break fi sleep 0.2 done echo "ready $ADDR:$SST_PORT/$MODULE/$lsn/$sst_ver" } check_extra() { local use_socket=1 if [ $uextra -eq 1 ]; then local thread_handling=$(parse_cnf '--mysqld' 'thread-handling') if [ "$thread_handling" = 'pool-of-threads' ]; then local eport=$(parse_cnf '--mysqld' 'extra-port') if [ -n "$eport" ]; then # mariadb-backup works only locally. # Hence, setting host to 127.0.0.1 unconditionally: wsrep_log_info "SST through extra_port $eport" INNOEXTRA="$INNOEXTRA --host=127.0.0.1 --port=$eport" use_socket=0 else wsrep_log_error "Extra port $eport null, failing" exit 1 fi else wsrep_log_info "Thread pool not set, ignore the option use_extra" fi fi if [ $use_socket -eq 1 -a -n "$WSREP_SST_OPT_SOCKET" ]; then INNOEXTRA="$INNOEXTRA --socket='$WSREP_SST_OPT_SOCKET'" fi } recv_joiner() { local dir="$1" local msg="$2" local tmt=$3 local checkf=$4 local wait=$5 if [ ! -d "$dir" ]; then # This indicates that IST is in progress return fi local ltcmd="$tcmd" if [ $tmt -gt 0 ]; then if [ -n "$(commandex timeout)" ]; then local koption=0 if [ "$OS" = 'FreeBSD' -o "$OS" = 'NetBSD' -o "$OS" = 'OpenBSD' -o \ "$OS" = 'DragonFly' ]; then if timeout 2>&1 | grep -qw -F -- '-k'; then koption=1 fi else if timeout --help | grep -qw -F -- '-k'; then koption=1 fi fi if [ $koption -ne 0 ]; then ltcmd="timeout -k $(( tmt+10 )) $tmt $tcmd" else ltcmd="timeout -s 9 $tmt $tcmd" fi fi fi if [ $wait -ne 0 ]; then wait_for_listen & fi cd "$dir" set +e timeit "$msg" "$ltcmd | $strmcmd; RC=( "\${PIPESTATUS[@]}" )" set -e cd "$OLD_PWD" if [ ${RC[0]} -eq 124 ]; then wsrep_log_error "Possible timeout in receiving first data from" \ "donor in gtid stage: exit codes: ${RC[@]}" exit 32 fi for ecode in "${RC[@]}"; do if [ $ecode -ne 0 ]; then wsrep_log_error "Error while getting data from donor node:" \ "exit codes: ${RC[@]}" exit 32 fi done if [ $checkf -eq 1 ]; then if [ ! -r "$MAGIC_FILE" ]; then # this message should cause joiner to abort: wsrep_log_error "receiving process ended without creating" \ "magic file ($MAGIC_FILE)" wsrep_log_info "Contents of datadir:" wsrep_log_info "$(ls -l "$dir"/*)" exit 32 fi if [ -n "$MY_SECRET" ]; then # Check donor supplied secret: SECRET=$(grep -m1 -E "^$SECRET_TAG[[:space:]]" "$MAGIC_FILE" || :) SECRET=$(trim_string "${SECRET#$SECRET_TAG}") if [ "$SECRET" != "$MY_SECRET" ]; then wsrep_log_error "Donor does not know my secret!" wsrep_log_info "Donor: '$SECRET', my: '$MY_SECRET'" exit 32 fi fi if [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # check total SST footprint payload=$(grep -m1 -E "^$TOTAL_TAG[[:space:]]" "$MAGIC_FILE" || :) if [ -n "$payload" ]; then payload=$(trim_string "${payload#$TOTAL_TAG}") if [ $payload -ge 0 ]; then # report to parent echo "$TOTAL_TAG $payload" fi fi fi fi } send_donor() { local dir="$1" local msg="$2" cd "$dir" set +e timeit "$msg" "$strmcmd | $tcmd; RC=( "\${PIPESTATUS[@]}" )" set -e cd "$OLD_PWD" for ecode in "${RC[@]}"; do if [ $ecode -ne 0 ]; then wsrep_log_error "Error while sending data to joiner node:" \ "exit codes: ${RC[@]}" exit 32 fi done } monitor_process() { local sst_stream_pid=$1 while :; do if ! ps -p $WSREP_SST_OPT_PARENT >/dev/null 2>&1; then wsrep_log_error \ "Parent mysqld process (PID: $WSREP_SST_OPT_PARENT)" \ "terminated unexpectedly." kill -- -$WSREP_SST_OPT_PARENT exit 32 fi if ! ps -p $sst_stream_pid >/dev/null 2>&1; then break fi sleep 0.1 done } read_cnf setup_ports if [ "$progress" = 'none' ]; then wsrep_log_info "All progress/rate-limiting disabled by configuration" elif [ -z "$(commandex pv)" ]; then wsrep_log_info "Progress reporting tool pv not found in path: $PATH" wsrep_log_info "Disabling all progress/rate-limiting" progress='none' fi if "$BACKUP_BIN" --help 2>/dev/null | grep -qw -F -- '--version-check'; then disver=' --no-version-check' fi get_stream get_transfer findopt='-L' [ "$OS" = 'FreeBSD' ] && findopt="$findopt -E" wait_previous_sst [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" [ -f "$DONOR_MAGIC_FILE" ] && rm -f "$DONOR_MAGIC_FILE" [ -f "$DATA/$IST_FILE" ] && rm -f "$DATA/$IST_FILE" if [ $ssyslog -eq 1 ]; then if [ -n "$(commandex logger)" ]; then wsrep_log_info "Logging all stderr of SST/mariadb-backup to syslog" exec 2> >(logger -p daemon.err -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE) wsrep_log_error() { logger -p daemon.err -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } wsrep_log_warning() { logger -p daemon.warning -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } wsrep_log_info() { logger -p daemon.info -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } else wsrep_log_error "logger not in path: $PATH. Ignoring" fi INNOAPPLY="2>&1 | logger -p daemon.err -t ${ssystag}innobackupex-apply" INNOMOVE="2>&1 | logger -p daemon.err -t ${ssystag}innobackupex-move" INNOBACKUP="2> >(logger -p daemon.err -t ${ssystag}innobackupex-backup)" else if [ $sstlogarchive -eq 1 ] then ARCHIVETIMESTAMP=$(date '+%Y.%m.%d-%H.%M.%S.%N') if [ -n "$sstlogarchivedir" ]; then if [ ! -d "$sstlogarchivedir" ]; then if ! mkdir -p "$sstlogarchivedir"; then sstlogarchivedir="" wsrep_log_warning \ "Unable to create '$sstlogarchivedir' directory" fi elif [ ! -w "$sstlogarchivedir" ]; then sstlogarchivedir="" wsrep_log_warning \ "The '$sstlogarchivedir' directory is not writtable" fi fi if [ -e "$INNOAPPLYLOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOAPPLYLOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOAPPLYLOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOAPPLYLOG' to '$newfile'" mv "$INNOAPPLYLOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi if [ -e "$INNOMOVELOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOMOVELOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOMOVELOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOMOVELOG' to '$newfile'" mv "$INNOMOVELOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi if [ -e "$INNOBACKUPLOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOBACKUPLOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOBACKUPLOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOBACKUPLOG' to '$newfile'" mv "$INNOBACKUPLOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi fi INNOAPPLY="> '$INNOAPPLYLOG' 2>&1" INNOMOVE="> '$INNOMOVELOG' 2>&1" INNOBACKUP="2> '$INNOBACKUPLOG'" fi setup_commands() { local mysqld_args="" if [ -n "$WSREP_SST_OPT_MYSQLD" ]; then mysqld_args=" --mysqld-args $WSREP_SST_OPT_MYSQLD" fi local recovery="" if [ -n "$INNODB_FORCE_RECOVERY" ]; then recovery=" --innodb-force-recovery=$INNODB_FORCE_RECOVERY" fi if [ -n "$use_memory" ]; then INNOEXTRA="$INNOEXTRA --use-memory=$use_memory" fi INNOAPPLY="$BACKUP_BIN --prepare$disver$recovery${iapts:+ }$iapts$INNOEXTRA --target-dir='$DATA' --datadir='$DATA'$mysqld_args $INNOAPPLY" INNOMOVE="$BACKUP_BIN$WSREP_SST_OPT_CONF --move-back$disver${impts:+ }$impts$INNOEXTRA --galera-info --force-non-empty-directories --target-dir='$DATA' --datadir='${TDATA:-$DATA}' $INNOMOVE" INNOBACKUP="$BACKUP_BIN$WSREP_SST_OPT_CONF --backup$disver${iopts:+ }$iopts$tmpopts$INNOEXTRA --galera-info --stream=$sfmt --target-dir='$itmpdir' --datadir='$DATA'$mysqld_args $INNOBACKUP" } send_magic() { # Store donor's wsrep GTID (state ID) and wsrep_gtid_domain_id # (separated by a space). echo "$WSREP_SST_OPT_GTID $WSREP_SST_OPT_GTID_DOMAIN_ID" > "$MAGIC_FILE" echo "$WSREP_SST_OPT_GTID $WSREP_SST_OPT_GTID_DOMAIN_ID" > "$DONOR_MAGIC_FILE" if [ -n "$WSREP_SST_OPT_REMOTE_PSWD" ]; then # Let joiner know that we know its secret echo "$SECRET_TAG $WSREP_SST_OPT_REMOTE_PSWD" >> "$MAGIC_FILE" fi if [ $WSREP_SST_OPT_BYPASS -eq 0 -a $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # Tell joiner what to expect: echo "$TOTAL_TAG $payload" >> "$MAGIC_FILE" fi } if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then trap cleanup_at_exit EXIT if [ $WSREP_SST_OPT_BYPASS -eq 0 ] then if [ -z "$sst_ver" ]; then wsrep_log_error "Upgrade joiner to 5.6.21 or higher for backup locks support" wsrep_log_error "The joiner is not supported for this version of donor" exit 93 fi tmpdir=$(parse_cnf "$encgroups" 'tmpdir') if [ -z "$tmpdir" ]; then xtmpdir="$(mktemp -d)" itmpdir="$(mktemp -d)" elif [ "$OS" = 'Linux' ]; then xtmpdir=$(mktemp -d "--tmpdir=$tmpdir") itmpdir=$(mktemp -d "--tmpdir=$tmpdir") else xtmpdir=$(TMPDIR="$tmpdir"; mktemp -d) itmpdir=$(TMPDIR="$tmpdir"; mktemp -d) fi wsrep_log_info "Using '$xtmpdir' as mariadb-backup temporary directory" tmpopts=" --tmpdir='$xtmpdir'" wsrep_log_info "Using '$itmpdir' as mariadb-backup working directory" if [ -n "$WSREP_SST_OPT_USER" ]; then INNOEXTRA="$INNOEXTRA --user='$WSREP_SST_OPT_USER'" fi if [ -n "$WSREP_SST_OPT_PSWD" ]; then export MYSQL_PWD="$WSREP_SST_OPT_PSWD" elif [ -n "$WSREP_SST_OPT_USER" ]; then # Empty password, used for testing, debugging etc. unset MYSQL_PWD fi check_extra if [ -n "$progress" -o $WSREP_SST_OPT_PROGRESS -eq 1 ]; then wsrep_log_info "Estimating total transfer size" get_footprint wsrep_log_info "To transfer: $payload" else adjust_progress fi wsrep_log_info "Streaming GTID file before SST" send_magic ttcmd="$tcmd" if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi get_keys if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi send_donor "$DATA" "$stagemsg-gtid" # Restore the transport commmand to its original state tcmd="$ttcmd" if [ -n "$pcmd" ]; then if [ -n "$rcmd" ]; then # redirect pv stderr to rcmd for tagging and output to parent tcmd="{ $pcmd 2>&3 | $tcmd; } 3>&1 | $rcmd" else # use user-configured pv output tcmd="$pcmd | $tcmd" fi fi wsrep_log_info "Sleeping before data transfer for SST" sleep 10 wsrep_log_info "Streaming the backup to joiner at $REMOTEIP:$SST_PORT" # Add compression to the head of the stream (if specified) if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi # Add encryption to the head of the stream (if specified) if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi iopts="--databases-exclude='lost+found'${iopts:+ }$iopts" # if compression is enabled for backup files, then add the # appropriate options to the mariadb-backup command line: if [ "$compress" != 'none' ]; then iopts="--compress${compress:+=$compress}${iopts:+ }$iopts" if [ -n "$compress_threads" ]; then iopts="--compress-threads=$compress_threads${iopts:+ }$iopts" fi if [ -n "$compress_chunk" ]; then iopts="--compress-chunk-size=$compress_chunk${iopts:+ }$iopts" fi fi if [ -n "$backup_threads" ]; then iopts="--parallel=$backup_threads${iopts:+ }$iopts" fi setup_commands set +e timeit "$stagemsg-SST" "$INNOBACKUP | $tcmd; RC=( "\${PIPESTATUS[@]}" )" set -e if [ ${RC[0]} -ne 0 ]; then wsrep_log_error "mariadb-backup finished with error: ${RC[0]}." \ "Check syslog or '$INNOBACKUPLOG' for details" exit 22 elif [ ${RC[$(( ${#RC[@]}-1 ))]} -eq 1 ]; then wsrep_log_error "$tcmd finished with error: ${RC[1]}" exit 22 fi else # BYPASS FOR IST wsrep_log_info "Bypassing the SST for IST" echo 'continue' # now server can resume updating data send_magic echo '1' > "$DATA/$IST_FILE" if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi get_keys if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi strmcmd="$strmcmd '$IST_FILE'" send_donor "$DATA" "$stagemsg-IST" fi echo "done $WSREP_SST_OPT_GTID" wsrep_log_info "Total time on donor: $totime seconds" else # joiner create_dirs 1 [ -e "$SST_PROGRESS_FILE" ] && \ wsrep_log_info "Stale sst_in_progress file: $SST_PROGRESS_FILE" [ -n "$SST_PROGRESS_FILE" ] && touch "$SST_PROGRESS_FILE" if [ -n "$backup_threads" ]; then impts="--parallel=$backup_threads${impts:+ }$impts" fi stagemsg='Joiner-Recv' MODULE="${WSREP_SST_OPT_MODULE:-xtrabackup_sst}" ADDR="$WSREP_SST_OPT_HOST" if [ "${tmode#VERIFY}" != "$tmode" ]; then # backward-incompatible behavior: CN="" if [ -n "$tpem" ]; then CN=$(openssl_getCN "$tpem") fi MY_SECRET="$(wsrep_gen_secret)" # Add authentication data to address ADDR="$CN:$MY_SECRET@$ADDR" else MY_SECRET="" # for check down in recv_joiner() fi get_keys if [ $encrypt -eq 1 ]; then strmcmd="$ecmd | $strmcmd" fi if [ -n "$sdecomp" ]; then strmcmd="$sdecomp | $strmcmd" fi check_sockets_utils trap cleanup_at_exit EXIT STATDIR="$(mktemp -d)" MAGIC_FILE="$STATDIR/$INFO_FILE" DONOR_MAGIC_FILE="$STATDIR/$DONOR_INFO_FILE" recv_joiner "$STATDIR" "$stagemsg-gtid" $stimeout 1 1 if ! ps -p "$WSREP_SST_OPT_PARENT" >/dev/null 2>&1; then wsrep_log_error "Parent mysqld process (PID: $WSREP_SST_OPT_PARENT)" \ "terminated unexpectedly." exit 32 fi if [ ! -r "$STATDIR/$IST_FILE" ]; then adjust_progress if [ -n "$pcmd" ]; then if [ -n "$rcmd" ]; then # redirect pv stderr to rcmd for tagging and output to parent strmcmd="{ $pcmd 2>&3 | $strmcmd; } 3>&1 | $rcmd" else # use user-configured pv output strmcmd="$pcmd | $strmcmd" fi fi if [ -d "$DATA/.sst" ]; then wsrep_log_info \ "WARNING: Stale temporary SST directory:" \ "'$DATA/.sst' from previous state transfer, removing..." rm -rf "$DATA/.sst" fi mkdir -p "$DATA/.sst" (recv_joiner "$DATA/.sst" "$stagemsg-SST" 0 0 0) & BACKUP_PID=$! wsrep_log_info "Proceeding with SST" get_binlog if [ -n "$WSREP_SST_OPT_BINLOG" ]; then binlog_dir=$(dirname "$WSREP_SST_OPT_BINLOG") binlog_base=$(basename "$WSREP_SST_OPT_BINLOG") binlog_index="$WSREP_SST_OPT_BINLOG_INDEX" cd "$DATA" wsrep_log_info "Cleaning the old binary logs" # If there is a file with binlogs state, delete it: [ -f "$binlog_base.state" ] && rm "$binlog_base.state" >&2 # Clean up the old binlog files and index: if [ -f "$binlog_index" ]; then while read bin_file || [ -n "$bin_file" ]; do rm -f "$bin_file" >&2 || : done < "$binlog_index" rm "$binlog_index" >&2 fi if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ -d "$binlog_dir" ] then cd "$binlog_dir" if [ "$(pwd)" != "$DATA_DIR" ]; then wsrep_log_info \ "Cleaning the binlog directory '$binlog_dir' as well" fi fi rm -f "$binlog_base".[0-9]* >&2 || : cd "$OLD_PWD" fi wsrep_log_info \ "Cleaning the existing datadir and innodb-data/log directories" find $findopt ${ib_home_dir:+"$ib_home_dir"} \ ${ib_undo_dir:+"$ib_undo_dir"} \ ${ib_log_dir:+"$ib_log_dir"} \ ${ar_log_dir:+"$ar_log_dir"} \ "$DATA" -mindepth 1 -prune -regex "$cpat" \ -o -exec rm -rf {} >&2 \+ # Deleting files from previous SST and legacy files from old versions: [ -f "$DATA/xtrabackup_binary" ] && rm -f "$DATA/xtrabackup_binary" [ -f "$DATA/xtrabackup_pid" ] && rm -f "$DATA/xtrabackup_pid" [ -f "$DATA/xtrabackup_checkpoints" ] && rm -f "$DATA/xtrabackup_checkpoints" [ -f "$DATA/xtrabackup_info" ] && rm -f "$DATA/xtrabackup_info" [ -f "$DATA/xtrabackup_slave_info" ] && rm -f "$DATA/xtrabackup_slave_info" [ -f "$DATA/xtrabackup_binlog_info" ] && rm -f "$DATA/xtrabackup_binlog_info" [ -f "$DATA/xtrabackup_binlog_pos_innodb" ] && rm -f "$DATA/xtrabackup_binlog_pos_innodb" TDATA="$DATA" DATA="$DATA/.sst" MAGIC_FILE="$DATA/$INFO_FILE" wsrep_log_info "Waiting for SST streaming to complete!" monitor_process $BACKUP_PID BACKUP_PID="" if [ ! -s "$DATA/xtrabackup_checkpoints" ]; then wsrep_log_error "xtrabackup_checkpoints missing," \ "failed mariadb-backup/SST on donor" exit 2 fi # Compact backups are not supported by mariadb-backup if grep -qw -F 'compact = 1' "$DATA/xtrabackup_checkpoints"; then wsrep_log_info "Index compaction detected" wsrep_log_error "Compact backups are not supported by mariadb-backup" exit 2 fi qpfiles=$(find $findopt "$DATA" -maxdepth 1 -type f -name '*.qp' -print -quit) if [ -n "$qpfiles" ]; then wsrep_log_info "Compressed qpress files found" if [ -z "$(commandex qpress)" ]; then wsrep_log_error "qpress utility not found in the path" exit 22 fi get_proc dcmd="xargs -n 2 qpress -dT$nproc" if [ -n "$progress" -a "$progress" != 'none' ] && \ pv --help | grep -qw -F -- '--line-mode' then count=$(find $findopt "$DATA" -maxdepth 1 -type f -name '*.qp' | wc -l) count=$(( count*2 )) pvopts='-f -l -N Decompression' pvformat="-F '%N => Rate:%r Elapsed:%t %e Progress: [%b/$count]'" payload=$count adjust_progress dcmd="$pcmd | $dcmd" fi # Decompress the qpress files wsrep_log_info "Decompression with $nproc threads" timeit 'Joiner-Decompression' \ "find $findopt '$DATA' -type f -name '*.qp' -printf '%p\n%h\n' | \ $dcmd" extcode=$? if [ $extcode -eq 0 ]; then wsrep_log_info "Removing qpress files after decompression" find $findopt "$DATA" -type f -name '*.qp' -delete if [ $? -ne 0 ]; then wsrep_log_error \ "Something went wrong with deletion of qpress files." \ "Investigate" fi else wsrep_log_error "Decompression failed. Exit code: $extcode" exit 22 fi fi wsrep_log_info "Preparing the backup at $DATA" setup_commands timeit 'mariadb-backup prepare stage' "$INNOAPPLY" if [ $? -ne 0 ]; then wsrep_log_error "mariadb-backup apply finished with errors." \ "Check syslog or '$INNOAPPLYLOG' for details." exit 22 fi if [ -n "$WSREP_SST_OPT_BINLOG" ]; then cd "$DATA" binlogs="" if [ -f 'xtrabackup_binlog_info' ]; then NL=$'\n' while read bin_string || [ -n "$bin_string" ]; do bin_file=$(echo "$bin_string" | cut -f1) if [ -f "$bin_file" ]; then binlogs="$binlogs${binlogs:+$NL}$bin_file" fi done < 'xtrabackup_binlog_info' else binlogs=$(ls -d -1 "$binlog_base".[0-9]* 2>/dev/null || :) fi cd "$DATA_DIR" if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ "$binlog_dir" != "$DATA_DIR" ] then [ ! -d "$binlog_dir" ] && mkdir -p "$binlog_dir" fi index_dir=$(dirname "$binlog_index"); if [ -n "$index_dir" -a "$index_dir" != '.' -a \ "$index_dir" != "$DATA_DIR" ] then [ ! -d "$index_dir" ] && mkdir -p "$index_dir" fi if [ -n "$binlogs" ]; then wsrep_log_info "Moving binary logs to $binlog_dir" echo "$binlogs" | \ while read bin_file || [ -n "$bin_file" ]; do mv "$DATA/$bin_file" "$binlog_dir" echo "$binlog_dir${binlog_dir:+/}$bin_file" >> "$binlog_index" done fi cd "$OLD_PWD" fi MAGIC_FILE="$TDATA/$INFO_FILE" DONOR_MAGIC_FILE="$TDATA/$DONOR_INFO_FILE" wsrep_log_info "Moving the backup to $TDATA" timeit 'mariadb-backup move stage' "$INNOMOVE" if [ $? -eq 0 ]; then wsrep_log_info "Move successful, removing $DATA" rm -rf "$DATA" DATA="$TDATA" else wsrep_log_error "Move failed, keeping '$DATA' for further diagnosis" wsrep_log_error "Check syslog or '$INNOMOVELOG' for details" exit 22 fi else wsrep_log_info "'$IST_FILE' received from donor: Running IST" if [ $WSREP_SST_OPT_BYPASS -eq 0 ]; then readonly WSREP_SST_OPT_BYPASS=1 readonly WSREP_TRANSFER_TYPE='IST' fi fi if [ ! -r "$MAGIC_FILE" ]; then wsrep_log_error "Internal error: SST magic file '$MAGIC_FILE'" \ "not found or not readable" exit 2 fi simulate_long_sst # use donor magic file, if present # if IST was used, donor magic file was not created # Remove special tags from the magic file, and from the output: if [ -r "$DONOR_MAGIC_FILE" ]; then coords=$(head -n1 "$DONOR_MAGIC_FILE") wsrep_log_info "Galera co-ords from donor: $coords" else coords=$(head -n1 "$MAGIC_FILE") wsrep_log_info "Galera co-ords from recovery: $coords" fi echo "$coords" # Output : UUID:seqno wsrep_gtid_domain_id wsrep_log_info "Total time on joiner: $totime seconds" fi wsrep_log_info "$WSREP_METHOD $WSREP_TRANSFER_TYPE completed on $WSREP_SST_OPT_ROLE" exit 0